
#include "common.hxx"
#include "basic.hxx"
#include "Config.hxx"
#include "Address.hxx"
#include "Input.hxx"
#include "Output.hxx"
#include "LongUDPSocket.hxx"
#include "ObjectPool.hxx"
#include "objects.hxx"
#include "simCollapse.h"
using namespace Rescue;

int main2(int argc, char** argv);
void commands(S32& time, Input& input, Output& output, LongUDPSocket& socket, Address& to, ObjectPool& pool,
              Buildings buildings, Buildings::const_iterator bit, Building* bPtr);
//void commands(S32& time, Header type, Input& input, ObjectPool& pool);
//void move(S32& time, MovingObject* agent, Input& input, ObjectPool& pool);

coordinates* getPoly(long int *plyNum, long int *pntNum, coordinates *polyPtr);
int collapse_check(Building* bPtr, int accel);
int getAccel(long int tx, long int ty, long int polyNum, coordinates* polyPtr);



int main(int argc, char** argv)
{
	try {
		return main2(argc, argv);
	} catch(std::exception& e) {
		fprintf(stderr, "%s\n", (const char*)e.what());
	} catch(...) {
		fprintf(stderr, "error...\n");
	}
	return 1;
}

int main2(int argc, char** argv)
{
	const char* host = "localhost";
	Config config;

	// 
	int i;
	int count = 0;
	for(i=1; i<argc; i++) {
		if(argv[i][0] == '-') {
			if(strcmp(argv[i], "-file") == 0) {
				if(++i < argc) {
					config.readConfigFile(argv[i]);
				} else {
					fprintf(stderr, "error: '-file'\n");
				}
			} else {
				if(++i < argc) {
					if(!config.setValue(argv[i-1]+1, argv[i]))
						fprintf(stderr, "error: '%s'\n", argv[i]);
				} else {
					fprintf(stderr, "error: '%s'\n", argv[i-1]);
				}
			}
		} else {
			switch(count++) {
			case 0:
				host = argv[i];
				break;
			default:
				fprintf(stderr, "error: '%s'\n", argv[i]);
				break;
			}
		}
	}

  //e錾
  Header type; //typeId
  long int objId; //object id
  Objects::const_iterator oit;
  Buildings buildings; //Building* ^郊Xg
  Buildings::const_iterator bit;
  Object* objPtr; //Objects^objectoĂɓ
  Building* bPtr;
  long int accel = 0;
  long int answer = 0; //ꂽ|x
  long int kscon = 0; //KS_CONNECT_OK𐔂
  long int kscom = 0; //KS_COMMANDS𐔂
  long int bNum = 0; //building̐
  long int cbNum = 0; //number of collapsed buildings

  
  //kẍ̒n}ǂݍ
  long int polyNum = 0;
  long int pointNum = 0;
  coordinates *polyPtr;
  polyPtr = getPoly(&polyNum, &pointNum, polyPtr);
  

	// \Pbg쐬
	LongUDPSocket socket;
	Input input;
	Output output;
	output.setWait(config.send_udp_wait());
	output.resetFrameSize(config.send_udp_size());
	Address to(host, config.port());	//M

	// ڑbZ[W𑗐M
	printf("connecting...\n");
	output.clear();								//o̓obt@ɂ
	output.put(SK_CONNECT);						//o̓obt@ SK_CONNECT (4oCg)o͂
	Output::Cursor base = output.put(~(S32)0);	//body ̃TCYƂĂƂ肠_~[̒lo͂ĂāAbase ɂ̈ʒuLB
	output.put(0);								//o̓obt@ 0 o͂
	output.setSize(base);						//base ŋLʒuɁAbase 炱܂ł put oCgݒ肷B
	output.put(HEADER_NULL);
	socket.send(output, to);					//output  put oCg to ֑MB

	// bZ[W[v
	S32 time = 0;
	ObjectPool pool;
	for(;;) {
		try {
			socket.receive(input);	// TODO: G[OŕԂ	//f[^MAinput ֒~B
			for(;;) {
				Header header = input.get();	//input (4oCg)f[^oAheader ֑
				if(header == HEADER_NULL)
					break;

				S32 size = input.get();
				Input::Cursor start = input.cursor();	//ݓǂݏoĂʒuL

				switch(header) {
				default:
					printf("Unknown header.\n");
					break;
				case KS_CONNECT_ERROR:
					printf("Connection failed.\n");
					return 1;
				case KS_CONNECT_OK:
					++kscon;
          if (kscon == 2)
            break;
          printf("Connect Ok %d.\n", kscon);
					// ack Ԃ
					output.clear();
					output.put(SK_ACKNOWLEDGE);
					output.put(~(S32)0);
					output.put(HEADER_NULL);
					socket.send(output, to);

					to = socket.addressRecievedFrom();	//ȍ~̑MύX
					pool.restructure(0, input);			//[hfB

          
          oit = pool.objects().begin();
          for( ; oit != pool.objects().end(); oit++){
            objPtr = *oit;
            type = objPtr->type();
            objId = objPtr->id();
            //printf("objId = %d\n", objId);
            
            switch(type){
            case TYPE_BUILDING:    
              ++bNum;
              bPtr = dynamic_cast<Building*>(objPtr);

              //printf("buildingAttribute of building %d = %d\n", bPtr->id(), bPtr->buildingAttributes());
           
              //W|S̃W[ɓn,x炤  
              //printf("(x, y) = (%d, %d)\t", bPtr->x(), bPtr->y());
              accel = getAccel(bPtr->x(), bPtr->y(), polyNum, polyPtr);
	      if (accel > 0)
		accel = accel-1;
              //printf("accel = %d\t", accel);
                            
              //œ|𔻒
              answer = collapse_check(bPtr, accel);
              bPtr->setBrokenness(time, answer);
              //printf("brokenness = %d\n", answer);

              //ʂ\
              //printf("building %d is collapsed %d %\n\n",objId, bPtr->brokenness() );

              //ꂽȂdifObjsɓ
              if (bPtr->brokenness() != 0){
                ++cbNum;
                buildings.push_back(bPtr);
              }

            } //switch
            
          } //for( ; oit != pool.objects().end(); oit++)

          printf("number of buildings = %d\n", bNum);
          printf("number of collapsed buildings = %d\n", cbNum);

          printf("end of KS_CONNECT_OK %d\n", kscon);
  				break;

				case KS_COMMANDS:
          ++kscom;
          printf("KS_COMMANDS %d\n", kscom);
					commands(time, input, output, socket, to, pool, buildings, bit, bPtr);
					printf("time = %ld.\n", (long)time);
          printf("end of KS_COMMANDS %d\n", kscom);
          return 0;
					break;

				case KS_UPDATE:
          printf("KS_UPDATE\n");
					time = input.get();
					pool.restructure(time, input);
					break;
				}

				input.setCursor(start);
				input.skip(size);						//size oCgXLbv
			}
		} catch(std::exception& e) {
			fprintf(stderr, "%s\n", (const char*)e.what());
		} catch(...) {
			fprintf(stderr, "error...\n");
		}
	}
	
	return 0;
}

void commands(S32& time, Input& input, Output& output, LongUDPSocket& socket, Address& to, ObjectPool& pool,
              Buildings buildings, Buildings::const_iterator bit, Building* bPtr)
{
  



  //ԂM
  time = input.get();

	// V~[Vʂ𑗐M
	output.clear();
	output.put(SK_UPDATE);
	Output::Cursor base = output.put(~(S32)0);

  bit = buildings.begin();
  int count = 0;
  for( ; bit != buildings.end(); bit++){
  //for( ; count <= 407 && bit != buildings.end(); count++, bit++){  
    bPtr = *bit;
    output.put(TYPE_BUILDING);    
    output.put(bPtr->id());
    output.put(PROPERTY_BROKENNESS);
    output.put(bPtr->brokenness());
    output.put(PROPERTY_NULL);
  } //for( ; bit != buildings.end(); bit++)

	pool.output(output, time);
	output.setSize(base);
	output.put(HEADER_NULL);
	socket.send(output, to);
}
