// RescueSystem.hxx
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(RESCUESYSTEM_HXX__INCLUDED) // {
#define RESCUESYSTEM_HXX__INCLUDED

#include "System.hxx"

namespace Rescue
{
	/////////////////////////////////////////////////////////////////////////
	// RescueSystem
	
	/** kernel ̃RA */
	class RescueSystem : public System
	{
	private:
		
	protected:
	public:
		virtual ~RescueSystem();
		RescueSystem();
		
		virtual void loop();
		virtual void sendToAngents();
		virtual void processCommand(Agent* agent, Header header, S32 size, Input& input, const LongUDPSocket& from);
		void say(Id from, Id target, char* message);
		
	private:
		RescueSystem(const RescueSystem& source);
		RescueSystem& operator= (const RescueSystem& rhs);
		bool operator== (const RescueSystem& rhs) const;
	};
	
	/////////////////////////////////////////////////////////////////////////
} // namespace Rescue

#ifdef NDEBUG
#  include "RescueSystem.inl"
#endif

#endif // } !defined(RESCUESYSTEM_HXX__INCLUDED)
